"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlHeader = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var theme_1 = require("./theme");
var theme_2 = require("./theme");
var theme_3 = require("./theme");
var FormatLineSpacing_1 = __importDefault(require("@mui/icons-material/FormatLineSpacing"));
var useDomRect_1 = require("powerhooks/useDomRect");
var powerhooks_1 = require("powerhooks");
var powerhooks_2 = require("powerhooks");
var GlDarkModeSwitch_1 = require("./utils/GlDarkModeSwitch");
var GlTemplate_1 = require("./GlTemplate");
var evt_1 = require("evt");
var tss_react_1 = require("tss-react");
var GlGithubStarCount_1 = require("./utils/GlGithubStarCount");
exports.GlHeader = (0, react_1.memo)(function (props) {
    var _a, _b;
    var links = props.links, title = props.title, className = props.className, enableDarkModeSwitch = props.enableDarkModeSwitch, githubButtonSize = props.githubButtonSize, githubRepoUrl = props.githubRepoUrl, showGithubStarCount = props.showGithubStarCount, titleDark = props.titleDark, titleSmallScreen = props.titleSmallScreen, titleSmallScreenDark = props.titleSmallScreenDark;
    var _c = __read((0, react_1.useState)(false), 2), isMenuUnfolded = _c[0], setIsMenuUnfolded = _c[1];
    var _d = (0, useDomRect_1.useDomRect)(), headerHeight = _d.domRect.height, headerRef = _d.ref;
    var _e = (0, useDomRect_1.useDomRect)(), linksHeight = _e.domRect.height, smallDeviceLinksRef = _e.ref;
    var linksRef = (0, react_1.useRef)(null);
    var titleRef = (0, react_1.useRef)(null);
    var _f = __read((0, react_1.useState)(0), 2), buttonsWidth = _f[0], setButtonsWidth = _f[1];
    var _g = __read((0, react_1.useState)(0), 2), titleWidth = _g[0], setTitleWidth = _g[1];
    (0, react_1.useEffect)(function () {
        if (!titleRef.current || !linksRef.current) {
            return;
        }
        setButtonsWidth(linksRef.current.clientWidth);
        setTitleWidth(titleRef.current.clientWidth);
    }, [(_a = titleRef.current) === null || _a === void 0 ? void 0 : _a.clientWidth, (_b = linksRef.current) === null || _b === void 0 ? void 0 : _b.clientWidth]);
    var rootRef = (0, powerhooks_2.useClickAway)(function () {
        if (!isMenuUnfolded) {
            return;
        }
        setIsMenuUnfolded(false);
    }).rootRef;
    var toggleMenu = (0, powerhooks_1.useConstCallback)(function () {
        setIsMenuUnfolded(!isMenuUnfolded);
    });
    (0, react_1.useEffect)(function () {
        var ctx = evt_1.Evt.newCtx();
        var scrollableElement = window.document.getElementById(GlTemplate_1.scrollableDivId);
        if (scrollableElement === null) {
            return;
        }
        evt_1.Evt.from(ctx, scrollableElement, "scroll").attach(function () {
            if (headerHeight < scrollableElement.scrollTop) {
                setIsMenuUnfolded(false);
            }
        });
    }, [headerHeight]);
    var _h = useStyles({
        headerHeight: headerHeight,
        isMenuUnfolded: isMenuUnfolded,
        linksHeight: linksHeight,
        buttonsWidth: buttonsWidth,
        titleWidth: titleWidth,
    }), classes = _h.classes, cx = _h.cx, theme = _h.theme;
    classes = (0, tss_react_1.useMergedClasses)(classes, props.classes);
    return ((0, jsx_runtime_1.jsx)("header", __assign({ className: cx(classes.root, className), ref: headerRef }, { children: (0, jsx_runtime_1.jsxs)("div", __assign({ ref: rootRef, className: classes.headerInner }, { children: [(0, jsx_runtime_1.jsx)("div", __assign({ ref: titleRef, className: classes.title }, { children: typeof title === "string" ? ((0, jsx_runtime_1.jsx)(theme_2.Text, __assign({ typo: "subtitle" }, { children: title }), void 0)) : ((function () {
                        var _a;
                        if (theme.windowInnerWidth >= theme_3.breakpointsValues.md) {
                            if (theme.isDarkModeEnabled) {
                                return titleDark !== null && titleDark !== void 0 ? titleDark : title;
                            }
                            return title;
                        }
                        if (theme.isDarkModeEnabled) {
                            return ((_a = titleSmallScreenDark !== null && titleSmallScreenDark !== void 0 ? titleSmallScreenDark : titleSmallScreen) !== null && _a !== void 0 ? _a : title);
                        }
                        return titleSmallScreen !== null && titleSmallScreen !== void 0 ? titleSmallScreen : title;
                    })()) }), void 0), (0, jsx_runtime_1.jsxs)("div", __assign({ ref: linksRef, className: classes.buttonAndLinkWrapper }, { children: [(0, jsx_runtime_1.jsx)(Links, { className: classes.links, links: links, classes: {
                                "text": classes.text,
                                "linkWrapper": classes.linkWrapper,
                                "linkUnderline": classes.linkUnderline,
                            } }, void 0), githubRepoUrl !== undefined && ((0, jsx_runtime_1.jsx)(GlGithubStarCount_1.GlGithubStarCount, { repoUrl: githubRepoUrl, size: githubButtonSize, showCount: showGithubStarCount, className: classes.githubStar }, void 0)), enableDarkModeSwitch !== undefined &&
                            enableDarkModeSwitch && ((0, jsx_runtime_1.jsx)("div", __assign({ className: classes.darkModeSwitch }, { children: (0, jsx_runtime_1.jsx)(GlDarkModeSwitch_1.GlDarkModeSwitch, { className: classes.darkModeSwitch }, void 0) }), void 0)), (0, jsx_runtime_1.jsx)("div", __assign({ onClick: toggleMenu }, { children: (0, jsx_runtime_1.jsx)(FormatLineSpacing_1.default, { className: classes.unfoldIcon }, void 0) }), void 0)] }), void 0), (0, jsx_runtime_1.jsx)("div", __assign({ className: classes.smallDeviceLinksWrapper }, { children: (0, jsx_runtime_1.jsx)("div", __assign({ className: classes.smallDeviceLinksInnerWrapper, ref: smallDeviceLinksRef }, { children: (0, jsx_runtime_1.jsx)(Links, { links: links, className: classes.smallDeviceLinks, classes: {
                                "link": classes.smallDeviceLink,
                                "text": classes.smallDeviceText,
                                "linkWrapper": classes.smallDeviceLinksInnerWrapper,
                                "linkUnderline": classes.smallDeviceLinkUnderline,
                            } }, void 0) }), void 0) }), void 0)] }), void 0) }), void 0));
});
var useStyles = (0, theme_1.makeStyles)()(function (theme, _a) {
    var headerHeight = _a.headerHeight, isMenuUnfolded = _a.isMenuUnfolded, linksHeight = _a.linksHeight, buttonsWidth = _a.buttonsWidth, titleWidth = _a.titleWidth;
    var isCollapsibleMenu = buttonsWidth + theme.spacing(9) + theme.paddingRightLeft * 2 >
        theme.windowInnerWidth - titleWidth ||
        theme.windowInnerWidth < theme_3.breakpointsValues.sm;
    return {
        "root": __assign(__assign({}, theme.spacing.rightLeft("padding", "".concat(theme.paddingRightLeft, "px"))), { "position": "relative" }),
        "headerInner": {
            "display": "flex",
            "justifyContent": "space-between",
            "alignItems": "center",
            "position": "relative",
        },
        "unfoldIcon": __assign(__assign({ "display": "none", "pointerEvents": "none" }, (isCollapsibleMenu
            ? {
                "display": "block",
                "pointerEvents": "unset",
            }
            : {})), { "marginLeft": theme.spacing(2) }),
        "smallDeviceLinksWrapper": __assign(__assign({ "position": "absolute", "backgroundColor": theme.colors.useCases.surfaces.background, "left": -theme.paddingRightLeft, "top": headerHeight + theme.spacing(3), "width": window.innerWidth, "opacity": 0, "height": 0, "overflow": "hidden", "pointerEvents": "none", "display": "flex", "flexDirection": "column", "alignItems": "flex-start", "justifyContent": "center", "transition": "height 300ms, border-top-color 300ms" }, theme.spacing.rightLeft("padding", "".concat(theme.paddingRightLeft, "px"))), (isCollapsibleMenu
            ? {
                "borderTop": isMenuUnfolded
                    ? "solid 1px ".concat(theme.colors.useCases.typography.textSecondary)
                    : undefined,
                "height": isMenuUnfolded ? linksHeight : 0,
                "opacity": 0.94,
                "pointerEvents": "unset",
            }
            : {})),
        "smallDeviceLinksInnerWrapper": __assign({}, theme.spacing.topBottom("padding", "".concat(theme.spacing(3), "px"))),
        "smallDeviceLinks": __assign({ "flexDirection": "column", "display": "flex" }, (isCollapsibleMenu
            ? {
                "opacity": 1,
                "pointerEvents": "unset",
            }
            : {})),
        "darkModeSwitch": __assign({}, (theme.windowInnerWidth < theme_3.breakpointsValues.md
            ? __assign({}, theme.spacing.rightLeft("margin", "".concat(theme.spacing(2), "px"))) : {})),
        "buttonAndLinkWrapper": {
            "position": "absolute",
            "right": 0,
            "display": "flex",
            "alignItems": "center",
        },
        "githubStar": __assign({}, (theme.windowInnerWidth >= theme_3.breakpointsValues.md
            ? {
                "paddingRight": theme.spacing(2),
            }
            : {})),
        "links": __assign({}, (function () {
            if (isCollapsibleMenu) {
                return {
                    "opacity": 0,
                    "pointerEvents": "none",
                };
            }
        })()),
        "title": {},
        "text": {},
        "linkWrapper": {},
        "linkUnderline": {},
        "smallDeviceText": {},
        "smallDeviceLink": {
            "margin": 0,
        },
        "smallDeviceLinkUnderline": {},
        "darkModeSwitchWrapper": {},
    };
});
var Links = (function () {
    var Links = (0, react_1.memo)(function (props) {
        var links = props.links, className = props.className;
        var _a = useStyles(), classes = _a.classes, cx = _a.cx;
        classes = (0, tss_react_1.useMergedClasses)(classes, props.classes);
        return ((0, jsx_runtime_1.jsx)("div", __assign({ className: cx(classes.links, className) }, { children: links.map(function (_a) {
                var href = _a.href, label = _a.label, onClick = _a.onClick;
                return ((0, jsx_runtime_1.jsx)("div", __assign({ className: classes.linkWrapper }, { children: (0, jsx_runtime_1.jsx)(Link, { className: classes.link, href: href, label: label, onClick: onClick, classes: {
                            "text": classes.text,
                            "underline": classes.linkUnderline,
                        } }, void 0) }), label));
            }) }), void 0));
    });
    var useStyles = (0, theme_1.makeStyles)()({
        "links": {
            "display": "flex",
            "justifyContent": "center",
            "flex": 1,
        },
        "linkWrapper": {
            "display": "flex",
            "cursor": "pointer",
        },
        "text": {},
        "linkUnderline": {},
        "link": {},
    });
    return { Links: Links };
})().Links;
var Link = (function () {
    var Link = (0, react_1.memo)(function (props) {
        var href = props.href, label = props.label, onClick = props.onClick, className = props.className;
        var _a = useStyles(), classes = _a.classes, cx = _a.cx;
        classes = (0, tss_react_1.useMergedClasses)(classes, props.classes);
        return ((0, jsx_runtime_1.jsxs)("div", __assign({ onClick: onClick !== null && onClick !== void 0 ? onClick : (function () { return (window.location.href = href); }), className: cx(classes.root, className) }, { children: [(0, jsx_runtime_1.jsx)(theme_2.Text, __assign({ typo: "label 1", className: classes.text }, { children: label }), void 0), (0, jsx_runtime_1.jsx)("div", { className: classes.underline }, void 0)] }), void 0));
    });
    var useStyles = (0, theme_1.makeStyles)()(function (theme, _params, classes) {
        var _a;
        return {
            "root": __assign(__assign(__assign({ "display": "flex", "flexDirection": "column", "position": "relative" }, theme.spacing.rightLeft("margin", "".concat(theme.spacing(3), "px"))), (_a = { "&: hover": {
                        "cursor": "pointer",
                    } }, _a["&:hover .".concat(classes.underline)] = __assign({ "width": "110%" }, (theme.windowInnerWidth < theme_3.breakpointsValues.md
                ? {
                    "width": "50%",
                }
                : {})), _a)), (theme.windowInnerWidth < theme_3.breakpointsValues.md
                ? __assign({}, theme.spacing.topBottom("margin", "".concat(theme.spacing(3), "px"))) : {})),
            "underline": {
                "width": 0,
                "position": "relative",
                "left": theme.windowInnerWidth >= theme_3.breakpointsValues.md
                    ? "-5%"
                    : "25%",
                "top": theme.spacing(1),
                "height": 1,
                "backgroundColor": theme.colors.useCases.typography.textPrimary,
                "transition": "width 200ms",
            },
            "text": __assign({}, theme.spacing.rightLeft("padding", "".concat(theme.spacing(2), "px"))),
        };
    });
    return { Link: Link };
})().Link;
//# sourceMappingURL=GlHeader.js.map